package be.iminds.ilabt.jfed.testing.base;

import javax.annotation.Nonnull;
import java.util.List;

/**
 * ApiTestMetaData
 */
public interface ApiTestMetaData {
    @Nonnull String getTestDescription();

    // old system:   (empty if new system)
    @Nonnull List<String> getReqConfKeys();
    @Nonnull List<String> getOptConfKeys();

    // new system:   (empty if old system)
//   @Nonnull Class/*<? extends ApiTestConfig>*/ getConfigClass();
    //parameters description list
    // each has:
    //   nest (list of keys in map, excluding last)   (ex:  for ansible.enable this is ["ansible"])
    //   name (last key in nested map)                (ex:  for ansible.enable this is "enable")
    //   description
    //   type: json type, so: map, list, double, int, boolean, string
    //   defaultValue
    //   allowNull: (  So: mandatory == (default == null && !allowNull)  )
    //   editorHint (optional):  multiline-5  multiline-json-20  multiline-xml-10    stringlist   urn   ...
}
